/*********************************
 * libScreenshot.c
 *
 * Ce fichier vous est fourni selon les termes de la GNU General Public Licence V3 ou superieure
 * dont une copie est disponible  l'adresse suivante :
 * http://www.gnu.org/licenses/gpl.txt
 */

#include <stdlib.h>
#include "fxlib.h"
#include "libScreenshot.h"

char ls_screenshot(unsigned char bLight[], unsigned char bDark[], BMP_params *params) {

	FONTCHARACTER PathName[]={'\\','\\','f','l','s','0','\\','s','c','r','n','s','h','o','t','.','b','m','p',0};
	int fileHandle;
	int fileSize = 4422;
	char r;
	BMP_RGBQuads pal[4];
	
	
	// /!\ Voir le commentaire dans libScreenshot.h sur la definiton des structures
	// pour les en-tetes.
	
	BMP_bfHeader fHead;
	BMP_biHeader iHead;
	
	fHead.bfType0 =			0x42;
	fHead.bfType1 =			0x4D;
	fHead.bfSize0 =			0x46;
	fHead.bfSize1 =			0x11;
	fHead.bfSize2 =			0x00;
	fHead.bfSize3 =			0x00;
	fHead.bfReserved0 =		0x00;
	fHead.bfReserved1 =		0x00;
	fHead.bfReserved2 =		0x00;
	fHead.bfReserved3 =		0x00;
	fHead.bfOffBits0 =  	0x46;
	fHead.bfOffBits1 =  	0x00;
	fHead.bfOffBits2 =  	0x00;
	fHead.bfOffBits3 =  	0x00;
	
	iHead.biSize0 = 		0x28;
	iHead.biSize1 = 		0x00;
	iHead.biSize2 = 		0x00;
	iHead.biSize3 = 		0x00;
	iHead.biWidth0 = 		0x80;
	iHead.biWidth1 = 		0x00;
	iHead.biWidth2 = 		0x00;
	iHead.biWidth3 = 		0x00;
	iHead.biHeight0 =		0x40;
	iHead.biHeight1 =		0x00;
	iHead.biHeight2 =		0x00;
	iHead.biHeight3 =		0x00;
	iHead.biPlanes0 = 		0x01;
	iHead.biPlanes1 = 		0x00;
	iHead.biBitCount0 =		0x04;
	iHead.biBitCount1 =		0x00;
	iHead.biCompression0 =	0x00;
	iHead.biCompression1 =	0x00;
	iHead.biCompression2 =	0x00;
	iHead.biCompression3 =	0x00;
	iHead.biSizeImage0 =	0x00;
	iHead.biSizeImage1 =	0x10;
	iHead.biSizeImage2 =	0x00;
	iHead.biSizeImage3 =	0x00;
	iHead.biXpelsPerMeter0 =0x00;
	iHead.biXpelsPerMeter1 =0x00;
	iHead.biXpelsPerMeter2 =0x00;
	iHead.biXpelsPerMeter3 =0x00;
	iHead.biYpelsPerMeter0 =0x00;
	iHead.biYpelsPerMeter1 =0x00;
	iHead.biYpelsPerMeter2 =0x00;
	iHead.biYpelsPerMeter3 =0x00;
	iHead.biClrUsed0 =		0x04;
	iHead.biClrUsed1 =		0x00;
	iHead.biClrUsed2 =		0x00;
	iHead.biClrUsed3 =		0x00;
	iHead.biClrImportant0 =	0x00;
	iHead.biClrImportant1 =	0x00;
	iHead.biClrImportant2 =	0x00;
	iHead.biClrImportant3 =	0x00;


	pal[0].rgbBlue = 			params->lum0;
	pal[0].rgbGreen = 			params->lum0;
	pal[0].rgbRed = 			params->lum0;
	pal[0].rgbReserved = 		0x00;
	
	pal[1].rgbBlue = 			params->lum1;
	pal[1].rgbGreen = 			params->lum1;
	pal[1].rgbRed = 			params->lum1;
	pal[1].rgbReserved = 		0x00;

	pal[2].rgbBlue = 			params->lum2;
	pal[2].rgbGreen = 			params->lum2;
	pal[2].rgbRed = 			params->lum2;
	pal[2].rgbReserved = 		0x00;

	pal[3].rgbBlue = 			params->lum3;
	pal[3].rgbGreen = 			params->lum3;
	pal[3].rgbRed = 			params->lum3;
	pal[3].rgbReserved = 		0x00;	
	
	if (Bfile_CreateFile(PathName, fileSize) != 0) {
		return 0;
	}
	
	fileHandle = Bfile_OpenFile(PathName, _OPENMODE_WRITE);
	
	Bfile_WriteFile(fileHandle, &fHead, sizeof(BMP_bfHeader));
	Bfile_WriteFile(fileHandle, &iHead, sizeof(BMP_biHeader));
	Bfile_WriteFile(fileHandle, pal, sizeof(BMP_RGBQuads) * 4);
	if (ls_writeBuffer(&fileHandle, bLight, bDark)) { // ecriture des buffers reussie
		Bfile_CloseFile(fileHandle);
		return 1;
	} else { // ecriture desdonnees echouee
		Bfile_CloseFile(fileHandle);
		// TODO : effacer le fichier cr
		return 0;
	}
}

char ls_writeBuffer(int *fileHandle, unsigned char bLight[], unsigned char bDark[]) {
	int readLineOffset, readByteOffset;
	int writeBuff;
	char r;
	
	for (readLineOffset = 1008; readLineOffset >= 0; readLineOffset -= 16) {
		for (readByteOffset = 0; readByteOffset < 16; readByteOffset++) {
			writeBuff = 0;
			for (r = 0; r < 8; r++) {
				if (TEST_BIT(bLight[readLineOffset + readByteOffset], r)) {
					writeBuff = SET_BIT(writeBuff, r * 4);
				}
				if (TEST_BIT(bDark[readLineOffset + readByteOffset], r)) {
					writeBuff = SET_BIT(writeBuff, r * 4 + 1);
				}
			}
			Bfile_WriteFile(*fileHandle, &writeBuff, sizeof(int));
		}
	}
	return 1;
}