/*********************************
 * libScreenshot.h
 *
 * Ce fichier vous est fourni selon les termes de la GNU General Public Licence V3 ou superieure
 * dont une copie est disponible  l'adresse suivante :
 * http://www.gnu.org/licenses/gpl.txt
 */

/****************************************************
               /!\ ATTENTION /!\
 ****************************************************
   Il y a un *horrible* bricolage sur les headers.
   Je ne sais pas d'o a viens (de la machine, de la norme C89, de mon incomptence ?), mais
   les donnes stockes dans un struct *semblent* toutes prendre la taille du type dfini le plus
   grand (je n'ai pas fait assez d'essais pour prouver cela, mais dans ce cas prcis, a y ressemble
   fort). Cela pose un gros problme lorsqu'il s'agit d'crire plusieurs types differents dans
   un fichier. 
   Les donnes  crire sont donc dcomposes en char pour le moment.
   Toute aide ou suggestions sur la question sera hautement apprcie ;)
*******************************************************/

#define TEST_BIT(VALUE, BIT) ((1<<(BIT)) & (VALUE))
#define SET_BIT(VALUE, BIT)   ((1<<(BIT)) | (VALUE))

typedef struct {
	char	bfType0,			// 'BM' (Ox424C) pour un bitmap Windows (2 octets)
			bfType1;
	char	bfSize0,			// Taille totale du fichier (4 octets)
			bfSize1,
			bfSize2,
			bfSize3;
	char	bfReserved0,		// 0 (2*2 octets)
			bfReserved1,
			bfReserved2,
			bfReserved3;
	char	bfOffBits0,			// Offset des bits du bitmap dans le fichier (4 octets)
			bfOffBits1,
			bfOffBits2,
			bfOffBits3;
} BMP_bfHeader;

typedef struct {
	char 	biSize0,			// Taille de cette structure en octets (4 octets)
			biSize1,
			biSize2,
			biSize3;
	char	biWidth0,			// Largeur du bitmap en pixel (4 octets)
			biWidth1,
			biWidth2,
			biWidth3;
	char	biHeight0,			// Hauteur du bitmap en pixel (4 octets)
			biHeight1,
			biHeight2,
			biHeight3;
	char	biPlanes0,			// 1 (2 octets)
			biPlanes1;
	char	biBitCount0,		// Bits couleurs par pixel (2 octets)
			biBitCount1;
	char	biCompression0,		// Schma de compactage (0 pour aucun) (4 octets)
			biCompression1,
			biCompression2,
			biCompression3;
	char	biSizeImage0,		// Taille de limage en octets (4 octets)
			biSizeImage1,
			biSizeImage2,
			biSizeImage3;
	char	biXpelsPerMeter0,	// Rsolution horizontale en pixels par mtre (4 octets)
			biXpelsPerMeter1,
			biXpelsPerMeter2,
			biXpelsPerMeter3;
	char	biYpelsPerMeter0,	// Rsolution verticale en pixels par mtre (4 octets)
			biYpelsPerMeter1,
			biYpelsPerMeter2,
			biYpelsPerMeter3;
	char	biClrUsed0,			// Nombre de couleurs utilises dans limage (4 octets)
			biClrUsed1,
			biClrUsed2,
			biClrUsed3;
	char	biClrImportant0,	// Nombre de couleurs importantes (4 octets)
			biClrImportant1,
			biClrImportant2,
			biClrImportant3;
} BMP_biHeader;

typedef struct {
	char	rgbBlue,			// intensit bleu
			rgbGreen,			// intensit vert
			rgbRed,				// intensit rouge
			rgbReserved;		// 0
} BMP_RGBQuads;

typedef struct {
	char 	lum0,
			lum1,
			lum2,
			lum3;
} BMP_params;

char ls_screenshot(unsigned char bLight[], unsigned char bDark[], BMP_params *params);
char ls_writeBuffer(int *fileHandle, unsigned char bLight[], unsigned char bDark[]);